;;; guile-irrlicht --- FFI bindings for Irrlicht Engine
;;; Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>
;;;
;;; This file is part of guile-irrlicht.
;;;
;;; Guile-irrlicht is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU Lesser General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; Guile-irrlicht is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with guile-irrlicht.  If not, see
;;; <http://www.gnu.org/licenses/>.


(define-module (irrlicht)
  #:use-module (oop goops)
  #:use-module (irrlicht base)
  #:use-module (irrlicht core)
  #:use-module (irrlicht device)
  #:use-module (irrlicht gui)
  #:use-module (irrlicht io)
  #:use-module (irrlicht irr)
  #:use-module (irrlicht scene)
  #:use-module (irrlicht video)
  #:duplicates (merge-generics)
  #:re-export (add-animated-mesh-scene-node!
               add-camera-scene-node!
               add-camera-scene-node-fps!
               add-custom-scene-node!
               add-file-archive!
               add-internal-point!
               add-octree-scene-node!
               add-static-text!
               begin-scene
               create-device
               drop!
               end-scene
               get-cursor-control
               get-file-system
               get-fps
               get-gui-environment
               get-mesh
               get-name
               get-position
               get-scene-manager
               get-texture
               get-video-driver
               is-empty?
               is-window-active?
               make-box3d
               make-material
               make-vertex3d
               reset-box3d!
               run
               set-material-flag!
               set-material-texture!
               set-md2-animation!
               set-position!
               set-visible!
               set-window-caption!
               yield-device))

;; Merged methods have to be exported apart
(re-export draw-all)
